//+------------------------------------------------------------------+
//|                                               Double trading.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//--- input parameters
extern string Commentation1= " :";
extern double    Lot=0.1;
extern double    StopLoss=500;
extern double    TakeProfit=500;
extern double    ProfitInPercent=1;
extern string Money1= "GBPUSD";//EURUSD
extern string Money2= "USDCHF";
extern string Money1_Sell\Buy="Sell";
extern string Money2_Sell\Buy="Sell";
//extern bool   OpenOnTrend=false;
extern int    Try=10;
extern string Commentation2= "  :";
//extern int    Open_HourTradeFirstDayOfWork        = 2;
extern bool   Monday=true;
extern bool   Tuesday=true;
extern bool   Wednesday=true;
extern bool   Thursday=true;
extern bool   Friday=true;
extern int    Close_HourTradeLastOfWork       = 16;
extern int    Close_HourOrdersInFriday       = 20;
extern int    Have_OrderHour  =2;
extern string Commentation3= "  IND_Correlation:";
extern int TimeframeInMinutes=1;
extern int Depth=50;
extern int Shift=0;
extern double ExpKoef=0.01;

int ticket1, ticket2, oldprofit,iWeek,Monday1,Tuesday2,Wednesday3,Thursday4,Friday5;
int i,OrderProfit1,OrderProfit2;
bool start=true, CorrelationF,CorrelationF1,CorrelationF2;
double Correlation1,Correlation2;
datetime ctm1,ctm2,closeorder;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
Money1_Sell\Buy = StringTrimLeft(Money1_Sell\Buy);
Money2_Sell\Buy = StringTrimLeft(Money2_Sell\Buy);
Money1_Sell\Buy = StringTrimRight(Money1_Sell\Buy);
Money2_Sell\Buy = StringTrimRight(Money2_Sell\Buy);


if (Monday==true)
{Monday1=1;
iWeek=1;}
if (Tuesday==true)
{Tuesday2=2;
iWeek=2;}
if (Wednesday==true)
{Wednesday3=3;
iWeek=3;}
if (Thursday==true)
{Thursday4=4;
iWeek=4;}
if (Friday==true)
{Friday5=5;
iWeek=5;}



Have_OrderHour = Have_OrderHour * 3600;


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
bool order1, order2;
//OpenOrder:
//if (OrderSelect(ticket1, SELECT_BY_TICKET)==false)


Correlation1=iCustom(Money1,TimeframeInMinutes,"IND_Correlation",Money1,Money2,Depth,Shift,ExpKoef,0,1);
Correlation2=iCustom(Money1,TimeframeInMinutes,"IND_Correlation",Money1,Money2,Depth,Shift,ExpKoef,1,1);



///Correlation signal
OrderSelect(ticket1, SELECT_BY_TICKET);
if (OrderCloseTime()!=0 || start == true)
{
OrderSelect(ticket2, SELECT_BY_TICKET);
if (OrderCloseTime()!=0 || start == true)
{
if (Correlation1 > Correlation2)
CorrelationF1=true;

if (CorrelationF1==true)
if (Correlation1 < Correlation2)
{CorrelationF=true;



   if (StringSubstr(Money1_Sell\Buy,0,1)=="a" || StringSubstr(Money1_Sell\Buy,0,1)=="A" || StringSubstr(Money2_Sell\Buy,0,1)=="a" || StringSubstr(Money2_Sell\Buy,0,1)=="A")
   {Money1_Sell\Buy="Sell";
   Money2_Sell\Buy="Sell";}}




if (Correlation1 < Correlation2)
CorrelationF2=true;

if (CorrelationF2==true)
if (Correlation1 > Correlation2)
{CorrelationF=true;



   if (StringSubstr(Money1_Sell\Buy,0,1)=="a" || StringSubstr(Money1_Sell\Buy,0,1)=="A" || StringSubstr(Money2_Sell\Buy,0,1)=="a" || StringSubstr(Money2_Sell\Buy,0,1)=="A")
   {Money1_Sell\Buy="Buy";
   Money2_Sell\Buy="Buy";}}




}}
///Correlation signal






if (!(iWeek==DayOfWeek() && Hour()>=Close_HourTradeLastOfWork))
{

if (CorrelationF==true && (Monday1==DayOfWeek()||Tuesday2==DayOfWeek()||Wednesday3==DayOfWeek()||Thursday4==DayOfWeek()||Friday5==DayOfWeek()))
{

ticket1=0;
ticket2=0;
i=0;
oldprofit=AccountProfit();
  while (ticket1<=0 && Try>i)
   {
   double bid   =MarketInfo(Money1,MODE_BID); //   Bid
   double ask   =MarketInfo(Money1,MODE_ASK); //   Ask
   double point =MarketInfo(Money1,MODE_POINT);// Point
   i =i+1;
   if (StringLen(Money1_Sell\Buy)==3)
   ticket1=OrderSend(Money1,OP_BUY,Lot,ask,3,bid-StopLoss*point,ask+TakeProfit*point,"","",0,Blue);
   else
   ticket1=OrderSend(Money1,OP_SELL,Lot,bid,3,ask+StopLoss*point,bid-TakeProfit*point,"","",0,Red);
   }
i=0;
   while (ticket2<=0 && Try>i)
   {
   bid   =MarketInfo(Money2,MODE_BID); //   Bid
   ask   =MarketInfo(Money2,MODE_ASK); //   Ask
   point =MarketInfo(Money2,MODE_POINT);// Point
   i =i+1;
   if (StringLen(Money2_Sell\Buy)==3)
   ticket2=OrderSend(Money2,OP_BUY,Lot,ask,3,bid-StopLoss*point,ask+TakeProfit*point,"","",0,Blue);
   else
   ticket2=OrderSend(Money2,OP_SELL,Lot,bid,3,ask+StopLoss*point,bid-TakeProfit*point,"","",0,Red);
   }
//}
//}
if (ticket1>0 && ticket2>0)
{
closeorder = TimeCurrent( ) + Have_OrderHour;

CorrelationF=false;
CorrelationF1=false;
CorrelationF2=false;
start=false;
}
}
}

//TakeProfit:
i=0;
OrderSelect(ticket1, SELECT_BY_TICKET);
OrderProfit1=OrderProfit();
ctm1=OrderCloseTime();

OrderSelect(ticket2, SELECT_BY_TICKET);
OrderProfit2=OrderProfit();
ctm2=OrderCloseTime();

if ((OrderProfit2+OrderProfit1>=(ProfitInPercent*AccountBalance())/100) || (Hour()>=Close_HourOrdersInFriday && 5==DayOfWeek()) || ctm1!=0 || ctm2!=0 || TimeCurrent( ) >=closeorder)
{
   while (order2==false && Try>i)
   {
   bid   =MarketInfo(Money2,MODE_BID); //   Bid
   ask   =MarketInfo(Money2,MODE_ASK); //   Ask
   if (StringLen(Money2_Sell\Buy)==3)
   order2=OrderClose(ticket2,Lot,bid,3,Green);
   else
   order2=OrderClose(ticket2,Lot,ask,3,Green);
   i=i+1;
   }
 i=0;
   while (order1==false && Try>i)
   {
   bid   =MarketInfo(Money1,MODE_BID); //   Bid
   ask   =MarketInfo(Money1,MODE_ASK); //   Ask
   if (StringLen(Money1_Sell\Buy)==3)
   order1=OrderClose(ticket1,Lot,bid,3,Green);
   else
   order1=OrderClose(ticket1,Lot,ask,3,Green);
   i=i+1;
   }   
   
}




//----
   return(0);
  }
//+------------------------------------------------------------------+